<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <suspense-query :query="versionsQuery" :delay-loading="500" transition="fade" transition-mode="out-in">
    <!-- Loading -->
    <template #loading>
      <page-loading />
    </template>

    <!-- Error -->
    <template #error>
      <page-error :error="versionsQueryError" />
    </template>

    <!-- Data -->
    <template #data>
      <!-- Handle a potential succes from one of the version cards -->
      <transition name="slide-y-transition" mode="out-in">
        <v-alert v-if="versionSuccess" class="studium-alert" dense text type="success">
          {{ versionSuccess }}
        </v-alert>
      </transition>

      <!-- Placeholder -->
      <content-placeholder v-if="versions.length === 0">
        <template #first>{{ $t('courses.description.version.list.not_available') }}</template>
      </content-placeholder>

      <!-- Versions -->
      <template v-else>
        <!-- Versions -->
        <course-description-version-card
          v-for="(version, index) in versionsDisplay"
          :key="index"
          v-model="isOpenIndex"
          :version="version"
          :course-code="courseCode"
          @success="onVersionSuccess"
        />

        <!-- Pagination -->
        <v-row class="pt-4" justify="end">
          <v-pagination
            v-model="page"
            class="studium-pagination"
            :length="pageLength"
            :total-visible="6"
            color="transparent"
          />
        </v-row>
      </template>
    </template>
  </suspense-query>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@nuxtjs/composition-api'

import { useCourseDescriptionVersionsQuery } from '~/apollo/_generated'
import { useErrorHandler } from '~/util/composables/'

export default defineComponent({
  props: {
    courseCode: {
      type: String,
      required: true,
    },
  },
  setup(props, { root }) {
    // Version that is currently collapsed
    const isOpenIndex = ref(-1)

    // Version info
    const versionsQuery = useCourseDescriptionVersionsQuery({ code: props.courseCode }, { fetchPolicy: 'no-cache' })
    const versionsQueryError = useErrorHandler(versionsQuery)
    const versions = computed(() => versionsQuery.result.value?.courseByCode?.description.versions ?? [])

    // Page index
    const page = ref(1)
    // Amount of courses per page
    const pageAmount = 10
    // Amount of pages
    const pageLength = computed(() => Math.ceil((versions.value?.length || 0) / pageAmount))

    // Versions to display
    const versionsDisplay = computed(
      () =>
        versions.value?.slice(
          // Start at the beginning of the page
          (page.value - 1) * pageAmount,

          // Show "searchPageAmount" courses
          (page.value - 1) * pageAmount + pageAmount
        ) || []
    )

    // Version success for one of the files
    const versionSuccess = ref<String | null>()

    // Handle version success
    function onVersionSuccess(message: String) {
      versionSuccess.value = message

      setTimeout(() => {
        versionSuccess.value = null
      }, 5000)

      // Scroll to the top so the user can see the success alert
      root.$vuetify.goTo(0)
    }

    return {
      isOpenIndex,
      versionsQuery,
      versionsQueryError,
      versions,
      versionsDisplay,
      page,
      pageAmount,
      pageLength,
      versionSuccess,
      onVersionSuccess,
    }
  },
})
</script>
